/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of MapHelper.xs. Do not edit this file, edit MapHelper.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MapHelper.xs"

#include <stdlib.h>
#include <stdio.h>
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "bheap.h"

typedef struct mapTile {
    short G;
    short H;
    int    parent;
    char   visited;
} mapTile;

typedef struct mapPath {
    short x;
    short y;
    struct mapPath *next;
} mapPath;

typedef struct mapInfo {
    unsigned short width;
    unsigned short height;
    char *hMap;
    unsigned char *rMap;
    unsigned char R;
} mapInfo;

int calcH(int x1,int y1,int x2,int y2)
{
    int x,y;
    x = (x1 > x2) ? x1-x2 : x2-x1;
    y = (y1 > y2) ? y1-y2 : y2-y1;
    return (x > y) ? x : y;
}

mapPath *newPathNode(int x, int y, mapPath *next)
{
    mapPath *node;

    node       = (mapPath *)calloc(1,sizeof(mapPath));
    node->x    = x;
    node->y    = y;
    node->next = next;

    return node;
}

void addPoint(AV *path, I32 x, I32 y)
{
    AV *point;

    point = newAV();
    av_push(point, newSVnv(x));
    av_push(point, newSVnv(y));
    av_unshift(path, 1);
    av_store(path, 0, newRV_inc((SV*)point));
    //fprintf(stderr, "Node: %d,%d\n",x,y);
}

// Recursively flood fill a region
// Yes - is bad, how do I *efficiently*
// flood fill a height map ?
// All location with height == 0 have
// their region set 1
int floodFill(mapInfo *map, unsigned short x, unsigned short y)
{
    int i,j;
    int crntH;

    int ret = 0;

    crntH = map->hMap[y*map->width+x];
    for(i=x-1;i<=x+1;i++) {
        for(j=y-1;j<=y+1;j++) {
            //fprintf(stderr, "  %d,%d\n",i,j);
            if (i>=0 && j>=0 && i<map->width && j<map->height) {
                unsigned char r = map->rMap[j*map->width+i];
                int h = map->hMap[j*map->width+i];
                //fprintf(stderr, "    onMap\n");
                if (h<=crntH+2 && h>=crntH-2 && r==0) {
                    if (h != 0) {
                        map->rMap[j*map->width+i] = map->R;
                        floodFill(map, (unsigned short)i,(unsigned short)j);
                        ret = 1;
                    }
                    else {
                        map->rMap[j*map->width+i] = 1;
                    }
                }
            }
        }
    }
    return ret;
}

#line 109 "MapHelper.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 253 "MapHelper.c"

XS_EUPXS(XS_Games__EternalLands__MapHelper_getZ); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Games__EternalLands__MapHelper_getZ)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "heightMap, width, height, x, y");
    {
	char *	heightMap = (char *)SvPV_nolen(ST(0))
;
	int	width = (int)SvIV(ST(1))
;
	int	height = (int)SvIV(ST(2))
;
	int	x = (int)SvIV(ST(3))
;
	int	y = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;
#line 109 "MapHelper.xs"
        int h;
        if (x < 0 || y < 0 || x >= width || y >= height)
            h = 0;
        else
            RETVAL = (int)heightMap[y*width+x];
#line 280 "MapHelper.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Games__EternalLands__MapHelper_findPathFromTo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Games__EternalLands__MapHelper_findPathFromTo)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "heightMap, width, height, fromX, fromY, toX, toY, delta");
    {
	char *	heightMap = (char *)SvPV_nolen(ST(0))
;
	int	width = (int)SvIV(ST(1))
;
	int	height = (int)SvIV(ST(2))
;
	int	fromX = (int)SvIV(ST(3))
;
	int	fromY = (int)SvIV(ST(4))
;
	int	toX = (int)SvIV(ST(5))
;
	int	toY = (int)SvIV(ST(6))
;
	int	delta = (int)SvIV(ST(7))
;
	SV *	RETVAL;
#line 128 "MapHelper.xs"
        bheap_t *openTiles;
        int crntTile, fromTile;
        int crntHeight,surrHeight;
        int nTiles;
        mapTile *tiles;
        int found = -1;
        AV *path;
        path = (AV *)sv_2mortal((SV *)newAV());

        nTiles    = width*height;
        tiles     = (mapTile *)calloc(nTiles, sizeof(mapTile));
        openTiles = bh_alloc(nTiles);
        fromTile  = fromY*width+fromX;

        //fprintf(stderr,"findPath(hBuf,%d,%d,%d,%d,%d,%d,%d\n",width,height,fromX,fromY,toX,toY,delta);

        tiles[fromTile].G       = 0;
        tiles[fromTile].H       = calcH(fromX,fromY,toX,toY);
        tiles[fromTile].parent  = -1;
        tiles[fromTile].visited = 1;
        bh_insert(openTiles, fromTile, 0);

        if (calcH(fromX,fromY,toX,toY) <= delta) {
            //fprintf(stderr,"No path needed: from-to <= %d\n",delta);
            found = fromTile;
        }
        while((openTiles->n > 0) && (found==-1)) {
            int x,y;
            int crntX,crntY,crntG;
            int crntTile = bh_min(openTiles);

            bh_delete(openTiles, crntTile);

            crntX      = crntTile % width;
            crntY      = crntTile / width;
            crntG      = tiles[crntTile].G;
            crntHeight = heightMap[crntTile];

            //fprintf(stderr,"I am at (%d,%d) G=%d H=%d Z=%d\n",crntX,crntY,crntG,tiles[crntTile].H,crntHeight);
            for(x=crntX-1; x<=crntX+1; x++) {
                for(y=crntY-1; y<=crntY+1; y++) {
                    int surrTile,surrG;
                    //fprintf(stderr, "  Considering (%d,%d)\n",x,y);
                    if ((x!=crntX || y!=crntY) &&  x >= 0 && y >= 0 && x < width && y < height) {
                        surrTile   = y*width+x;
                        surrHeight = heightMap[surrTile];
                        if (surrHeight!=0 && (surrHeight >=crntHeight-2) && (surrHeight <= crntHeight+2)) {
                            surrG = crntG+1;
                            if (tiles[surrTile].visited) {
                                //fprintf(stderr,"    Node has been visited before\n");
                                if (surrG < tiles[surrTile].G) {
                                    //fprintf(stderr,"      Better path %d < %d\n",surrG,tiles[surrTile].G);
                                    tiles[surrTile].G       = surrG;
                                    tiles[surrTile].parent  = crntTile;
                                    bh_decrease_key(openTiles, surrTile, surrG+tiles[surrTile].H);
                                }
                            }
                            else {
                                //fprintf(stderr,"    New node\n");
                                tiles[surrTile].G       = surrG;
                                tiles[surrTile].H       = calcH(x,y,toX,toY);
                                tiles[surrTile].parent  = crntTile;
                                tiles[surrTile].visited = 1;
                                if (tiles[surrTile].H <= delta) {
                                    //fprintf(stderr,"    found: %d < %d\n",tiles[surrTile].H,delta);
                                    found = surrTile;
                                }
                                else {
                                    //fprintf(stderr,"    queueing\n");
                                    bh_insert(openTiles, surrTile, surrG+tiles[surrTile].H);
                                }
                            }
                        }
                        //else fprintf(stderr,"Skipping - height diff > 2\n");
                    }
                    //else fprintf(stderr,"Skipping - not on the map\n");
                }
            }
        }
        if (found != -1) {
            int parent;
            addPoint(path, found%width, found/width);
            parent = tiles[found].parent;
            while(parent != -1) {
                addPoint(path, parent%width, parent/width);
                parent = tiles[parent].parent;
            }
            RETVAL = newRV_inc((SV *)path);
        }
        else {
            RETVAL = &PL_sv_undef;
        }
        free(tiles);
        bh_free(openTiles);
#line 406 "MapHelper.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Games__EternalLands__MapHelper_getRegion); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Games__EternalLands__MapHelper_getRegion)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "rMap, width, height, x, y");
    {
	char *	rMap = (char *)SvPV_nolen(ST(0))
;
	int	width = (int)SvIV(ST(1))
;
	int	height = (int)SvIV(ST(2))
;
	int	x = (int)SvIV(ST(3))
;
	int	y = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;
#line 233 "MapHelper.xs"
        unsigned short *regions = (unsigned short *)rMap;

        if (x<0 || y<0 || x>=width || y>=height)
            RETVAL = 0;
        else
            RETVAL = (int)regions[y*width+x];
#line 440 "MapHelper.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Games__EternalLands__MapHelper_findRegions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Games__EternalLands__MapHelper_findRegions)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "hMap, rMap, width, height");
    {
	char *	hMap = (char *)SvPV_nolen(ST(0))
;
	char *	rMap = (char *)SvPV_nolen(ST(1))
;
	unsigned short	width = (unsigned short)SvUV(ST(2))
;
	unsigned short	height = (unsigned short)SvUV(ST(3))
;
#line 249 "MapHelper.xs"
        unsigned short x,y;
        mapInfo map;

        map.width  = width;
        map.height = height;
        map.hMap   = hMap;
        map.rMap   = (unsigned char *)rMap;
        map.R      = 2; // R=1 is reserved for unreachable locations

        //fprintf(stderr,"Initialiazing rMap to 0\n");
        memset(rMap,0,width*height);
        for(x=0;x<width;x++) {
            for(y=0;y<height;y++) {
                if (map.rMap[y*width+x] == 0) {
                    //fprintf(stderr, "Flood filling from %d,%d with %d\n",x,y,map.R);
                    if (floodFill(&map,x,y))
                        map.R++;
                }
            }
        }
#line 483 "MapHelper.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Games__EternalLands__MapHelper); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Games__EternalLands__MapHelper)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Games::EternalLands::MapHelper::getZ", XS_Games__EternalLands__MapHelper_getZ);
        newXS_deffile("Games::EternalLands::MapHelper::findPathFromTo", XS_Games__EternalLands__MapHelper_findPathFromTo);
        newXS_deffile("Games::EternalLands::MapHelper::getRegion", XS_Games__EternalLands__MapHelper_getRegion);
        newXS_deffile("Games::EternalLands::MapHelper::findRegions", XS_Games__EternalLands__MapHelper_findRegions);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

